var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "react/jsx-runtime";
import { isNumber, isString, isUndefined } from 'lodash';
import React, { useEffect, useRef } from 'react';
import ReactDOM from 'react-dom';
import { useAsync, useEvent, useId, useLockScroll, useRefExtra } from '@react-devui/hooks';
import { CheckCircleOutlined, CloseCircleOutlined, ExclamationCircleOutlined, WarningOutlined } from '@react-devui/icons';
import { checkNodeExist, getClassName } from '@react-devui/utils';
import { useMaxIndex, useDValue } from '../../hooks';
import { registerComponentMate, handleModalKeyDown, TTANSITION_DURING_BASE } from '../../utils';
import { DMask } from '../_mask';
import { DTransition } from '../_transition';
import { useComponentConfig, usePrefixConfig } from '../root';
import { DModalFooter } from './ModalFooter';
import { DModalHeader } from './ModalHeader';
const { COMPONENT_NAME } = registerComponentMate({ COMPONENT_NAME: 'DModal' });
export const DModal = (props) => {
    const _a = useComponentConfig(COMPONENT_NAME, props), { children, dVisible, dWidth = 520, dTop = 100, dZIndex, dMask = true, dMaskClosable = true, dEscClosable = true, dType, dHeader, dFooter, onVisibleChange, afterVisibleChange } = _a, restProps = __rest(_a, ["children", "dVisible", "dWidth", "dTop", "dZIndex", "dMask", "dMaskClosable", "dEscClosable", "dType", "dHeader", "dFooter", "onVisibleChange", "afterVisibleChange"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    //#endregion
    //#region Ref
    const modalRef = useRef(null);
    const modalContentRef = useRef(null);
    const containerRef = useRefExtra(() => {
        let el = document.getElementById(`${dPrefix}modal-root`);
        if (!el) {
            el = document.createElement('div');
            el.id = `${dPrefix}modal-root`;
            document.body.appendChild(el);
        }
        return el;
    }, true);
    const windowRef = useRefExtra(() => window);
    //#endregion
    const dataRef = useRef({
        x: 0,
        y: 0,
        prevActiveEl: null,
    });
    const async = useAsync();
    const uniqueId = useId();
    const titleId = `${dPrefix}modal-title-${uniqueId}`;
    const bodyId = `${dPrefix}modal-content-${uniqueId}`;
    const topStyle = dTop + (isNumber(dTop) ? 'px' : '');
    const [visible, changeVisible] = useDValue(false, dVisible, onVisibleChange);
    const maxZIndex = useMaxIndex(visible);
    const zIndex = (() => {
        if (!isUndefined(dZIndex)) {
            return dZIndex;
        }
        return maxZIndex;
    })();
    useLockScroll(visible);
    useEffect(() => {
        if (visible) {
            dataRef.current.prevActiveEl = document.activeElement;
            if (modalRef.current) {
                modalRef.current.focus({ preventScroll: true });
            }
        }
        else if (dataRef.current.prevActiveEl) {
            dataRef.current.prevActiveEl.focus({ preventScroll: true });
        }
    }, [visible]);
    useEvent(windowRef, 'click', (e) => {
        var _a, _b;
        dataRef.current.x = e.clientX;
        dataRef.current.y = e.clientY;
        (_b = (_a = dataRef.current).clearTid) === null || _b === void 0 ? void 0 : _b.call(_a);
        dataRef.current.clearTid = async.setTimeout(() => {
            dataRef.current.clearTid = undefined;
        }, 20);
    }, { capture: true }, visible);
    const headerNode = (() => {
        if (dHeader) {
            const node = isString(dHeader) ? _jsx(DModalHeader, { children: dHeader }) : dHeader;
            return React.cloneElement(node, {
                __id: titleId,
                __onClose: () => {
                    changeVisible(false);
                },
            });
        }
    })();
    return (containerRef.current &&
        ReactDOM.createPortal(_jsx(DTransition, Object.assign({ dIn: visible, dDuring: TTANSITION_DURING_BASE, onEnter: () => {
                if (isUndefined(dataRef.current.clearTid)) {
                    dataRef.current.transformOrigin = undefined;
                }
                else if (modalContentRef.current) {
                    const left = `${(window.innerWidth - modalContentRef.current.clientWidth) / 2}px`;
                    const top = dTop === 'center' ? `${(window.innerHeight - modalContentRef.current.clientHeight) / 2}px` : topStyle;
                    dataRef.current.transformOrigin = `calc(${dataRef.current.x}px - ${left}) calc(${dataRef.current.y}px - ${top})`;
                }
            }, afterEnter: () => {
                afterVisibleChange === null || afterVisibleChange === void 0 ? void 0 : afterVisibleChange(true);
            }, afterLeave: () => {
                afterVisibleChange === null || afterVisibleChange === void 0 ? void 0 : afterVisibleChange(false);
            } }, { children: (state) => {
                let transitionStyle = {};
                switch (state) {
                    case 'enter':
                        transitionStyle = { transform: 'scale(0.3)', opacity: 0 };
                        break;
                    case 'entering':
                        transitionStyle = {
                            transition: ['transform', 'opacity'].map((attr) => `${attr} ${TTANSITION_DURING_BASE}ms ease-out`).join(', '),
                            transformOrigin: dataRef.current.transformOrigin,
                        };
                        break;
                    case 'leaving':
                        transitionStyle = {
                            transform: 'scale(0.3)',
                            opacity: 0,
                            transition: ['transform', 'opacity'].map((attr) => `${attr} ${TTANSITION_DURING_BASE}ms ease-in`).join(', '),
                            transformOrigin: dataRef.current.transformOrigin,
                        };
                        break;
                    default:
                        break;
                }
                return (_jsxs("div", Object.assign({}, restProps, { ref: modalRef, className: getClassName(restProps.className, `${dPrefix}modal`, {
                        [`${dPrefix}modal--center`]: dTop === 'center',
                        [`${dPrefix}modal--type`]: dType,
                    }), style: Object.assign(Object.assign({}, restProps.style), { display: state === 'leaved' ? 'none' : undefined, zIndex }), tabIndex: -1, role: "dialog", "aria-modal": true, "aria-labelledby": headerNode ? titleId : undefined, "aria-describedby": bodyId, onKeyDown: (e) => {
                        var _a;
                        (_a = restProps.onKeyDown) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
                        if (dEscClosable && e.code === 'Escape') {
                            changeVisible(false);
                        }
                        handleModalKeyDown(e);
                    } }, { children: [dMask && (_jsx(DMask, { dVisible: visible, onClose: () => {
                                if (dMaskClosable) {
                                    changeVisible(false);
                                }
                            } })), _jsxs("div", Object.assign({ ref: modalContentRef, className: `${dPrefix}modal__content`, style: Object.assign({ width: dWidth, top: dTop === 'center' ? undefined : dTop, maxHeight: dTop === 'center' ? undefined : `calc(100% - ${topStyle} - 20px)` }, transitionStyle) }, { children: [headerNode, _jsx("div", Object.assign({ id: bodyId, className: `${dPrefix}modal__body` }, { children: dType ? (_jsxs(_Fragment, { children: [_jsx("div", Object.assign({ className: `${dPrefix}modal__icon` }, { children: checkNodeExist(dType.icon) ? (dType.icon) : dType.type === 'success' ? (_jsx(CheckCircleOutlined, { dTheme: "success" })) : dType.type === 'warning' ? (_jsx(WarningOutlined, { dTheme: "warning" })) : dType.type === 'error' ? (_jsx(CloseCircleOutlined, { dTheme: "danger" })) : (_jsx(ExclamationCircleOutlined, { dTheme: "primary" })) })), _jsxs("div", Object.assign({ className: `${dPrefix}modal__type-wrapper` }, { children: [checkNodeExist(dType.title) && _jsx("div", Object.assign({ className: `${dPrefix}modal__title` }, { children: dType.title })), checkNodeExist(dType.description) && _jsx("div", Object.assign({ className: `${dPrefix}modal__description` }, { children: dType.description }))] }))] })) : (children) })), dFooter &&
                                    React.cloneElement(dFooter, {
                                        __onClose: () => {
                                            changeVisible(false);
                                        },
                                    })] }))] })));
            } })), containerRef.current));
};
DModal.Header = DModalHeader;
DModal.Footer = DModalFooter;
