var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx } from "react/jsx-runtime";
import { useRef } from 'react';
import { registerComponentMate } from '../../utils';
import { DAlertPopover } from '../_alert-popover';
import { DTransition } from '../_transition';
import { useComponentConfig } from '../root';
import { DPanel } from './Panel';
const TTANSITION_DURING = { enter: 133, leave: 166 };
const { COMPONENT_NAME } = registerComponentMate({ COMPONENT_NAME: 'DNotification' });
export function DNotification(props) {
    const _a = useComponentConfig(COMPONENT_NAME, props), { dVisible, dType, dIcon, dTitle, dDescription, dDuration = 9.6, dPlacement = 'right-top', dActions = ['close'], dEscClosable = true, onClose, afterVisibleChange } = _a, restProps = __rest(_a, ["dVisible", "dType", "dIcon", "dTitle", "dDescription", "dDuration", "dPlacement", "dActions", "dEscClosable", "onClose", "afterVisibleChange"]);
    //#region Ref
    const panelRef = useRef(null);
    //#endregion
    return (_jsx(DTransition, Object.assign({ dIn: dVisible, dDuring: TTANSITION_DURING, dSkipFirstTransition: false, afterEnter: () => {
            afterVisibleChange === null || afterVisibleChange === void 0 ? void 0 : afterVisibleChange(true);
        }, afterLeave: () => {
            afterVisibleChange === null || afterVisibleChange === void 0 ? void 0 : afterVisibleChange(false);
        } }, { children: (state) => {
            let transitionStyle = {};
            switch (state) {
                case 'enter':
                    transitionStyle = {
                        transform: dPlacement === 'left-top' || dPlacement === 'left-bottom' ? 'translate(-100%, 0)' : 'translate(100%, 0)',
                    };
                    break;
                case 'entering':
                    transitionStyle = {
                        transition: ['transform'].map((attr) => `${attr} ${TTANSITION_DURING.enter}ms ease-out`).join(', '),
                    };
                    break;
                case 'leave':
                    if (panelRef.current) {
                        const { height } = panelRef.current.getBoundingClientRect();
                        transitionStyle = { height, overflow: 'hidden' };
                    }
                    break;
                case 'leaving':
                    transitionStyle = {
                        height: 0,
                        overflow: 'hidden',
                        paddingTop: 0,
                        paddingBottom: 0,
                        marginTop: 0,
                        marginBottom: 0,
                        opacity: 0,
                        transition: ['height', 'padding', 'margin', 'opacity']
                            .map((attr) => `${attr} ${TTANSITION_DURING.leave}ms ease-in`)
                            .join(', '),
                    };
                    break;
                case 'leaved':
                    transitionStyle = { display: 'none' };
                    break;
                default:
                    break;
            }
            return (_jsx(DAlertPopover, Object.assign({ dDuration: dDuration, dEscClosable: dEscClosable, onClose: onClose }, { children: ({ render }) => render(_jsx(DPanel, Object.assign({}, restProps, { ref: panelRef, style: Object.assign(Object.assign({}, restProps.style), transitionStyle), dClassNamePrefix: "notification", dType: dType, dIcon: dIcon, dTitle: dTitle, dDescription: dDescription, dActions: dActions, onClose: onClose }))) })));
        } })));
}
