import { Subject } from 'rxjs';
export const TOAST_SUBJECT = {
    open$: new Subject(),
    close$: new Subject(),
    rerender$: new Subject(),
    closeAll$: new Subject(),
};
class Toast {
    constructor(_uniqueId) {
        Object.defineProperty(this, "_uniqueId", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: _uniqueId
        });
    }
    get uniqueId() {
        return this._uniqueId;
    }
    close() {
        ToastService.close(this._uniqueId);
    }
    rerender(props) {
        ToastService.rerender(this._uniqueId, props);
    }
}
let TOASTS = [];
let UNIQUEID = 1;
export class ToastService {
    static get toasts() {
        return TOASTS;
    }
    static open(props) {
        UNIQUEID += 1;
        TOAST_SUBJECT.open$.next({ uniqueId: UNIQUEID, props });
        const toast = new Toast(UNIQUEID);
        TOASTS.push(toast);
        return toast;
    }
    static close(uniqueId) {
        TOASTS = TOASTS.filter((item) => item.uniqueId !== uniqueId);
        TOAST_SUBJECT.close$.next(uniqueId);
    }
    static rerender(uniqueId, props) {
        TOAST_SUBJECT.rerender$.next({ uniqueId, props });
    }
    static closeAll(animation = true) {
        TOASTS = [];
        TOAST_SUBJECT.closeAll$.next(animation);
    }
}
